--[[
	RealisticSeederFix.lua
	
	Autor: 		Ifko[nator]
	Datum: 		22.03.2023
	Version: 	1.0
	
	Changelog:	v1.0 @ 22.03.2023 - initial implementation in FS 22
]]

RealisticSeederFix = {};

function RealisticSeederFix:finalizeTypes()
	for _, mod in pairs(g_modManager.mods) do
		if _G[tostring(mod.modName)].RealisticSeeder ~= nil then		
			if g_modIsLoaded[tostring(mod.modName)] then	
				
				FillUnit.updateUnloadActionDisplay = RealisticSeederFix.updateUnloadActionDisplay;
				
				break;
			end;
		end;
	end;
end;

TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes, RealisticSeederFix.finalizeTypes);

function RealisticSeederFix:updateUnloadActionDisplay(superFunc)
	if self.spec_fillUnit.unloading ~= nil then
		local isActive = self.spec_sprayer ~= nil;

		if not isActive then
			for fillUnitNumber, fillUnit in ipairs(self:getFillUnits()) do
				local fillLevel = self:getFillUnitFillLevel(fillUnitNumber);
				local fillTypeIndex = self:getFillUnitFillType(fillUnitNumber);
				local fillType = g_fillTypeManager:getFillTypeByIndex(fillTypeIndex);

				if fillUnit.canBeUnloaded and fillLevel > 0 and fillType.palletFilename ~= nil then
					isActive = 
						fillType.name == "HERBICIDE" or
						fillType.name == "LIQUID_FERTILIZER" or
						fillType.name == "FISH" or
						fillType.name == "CHERRY"
					;

					break;
				end;
			end;
		end;

		if self.getCurrentDischargeNode ~= nil then
			local dischargeNode = self:getCurrentDischargeNode();

			if dischargeNode ~= nil then
				local dischargeObject, _ = self:getDischargeTargetObject(dischargeNode);

				if dischargeObject ~= nil then
					isActive = false;
				end;
			end;
		end;
		
		g_inputBinding:setActionEventActive(self.spec_fillUnit.unloadActionEventId, isActive);
	end;
end;